Please note: This project is no longer active. The website is kept online for historic purposes only.
If you´re looking for a Linux driver for your Atheros WLAN device, you should continue here .

Ticket #1015 (new defect)

Opened 15 years ago

Last modified 13 years ago

[patch] Atheros AP61(AR2317) board crash fixed.

Reported by: Eric L. Chen <lihong.chen@gmail.com> Assigned to:
Priority: major Milestone:
Component: madwifi: driver Version: trunk
Keywords: AP61 AR2317 OpenWrt Cc:
Patch is attached: 1 Pending:

Description

I am porting OpenWrt? to AP61 board. The board will crash while insert ath_ahb.o module. I built madwifi-ng from subversion trun (r1811), it need some patch to prevent this crash. The patch just fixed the crash issue, but HAL still not detects AR2317 chip. So you will got HAL status 1 (hardware not found) response. This is very strange since there is ap61.hal.o.uu existing in hal/public and compile successfully.

Signed-off-by: Eric L. Chen <lihong.chen@gmail.com>

Attachments

madwifi-ng-ap61-fixed.patch (4.1 kB) - added by Eric L. Chen <lihong.chen@gmail.com> on 11/16/06 11:55:11.
Fix crash issue for AP61 board

Change History

11/16/06 11:55:11 changed by Eric L. Chen <lihong.chen@gmail.com>

  • attachment madwifi-ng-ap61-fixed.patch added.

Fix crash issue for AP61 board

11/16/06 14:13:52 changed by mrenzmann

Thanks for the patch.

Can you confirm that the changes to the addresses used in context of bd_config and radio_config will not affect other SoC variants that also use AHB?

(follow-up: ↓ 5 ) 11/16/06 15:53:09 changed by Eric L. Chen <lihong.chen@gmail.com>

Yes. Atheros made 0xbfc00000 alias to 0xa800000 in whole AR531X family. So, for all SoC boards with more than 4 MByte flash port, must use 0xa8000000 to access it. For boards with 4MB flash, use 0xa8000000 and 0xbfc0000 is the same. But for boards with more than 4MB flash, use 0xbfc00000 will limit to 4MB (0xbfc00000-0xbfffffff). So, 0xa8000000 is the first choice, since it supports any size of flash rom.

We also need wait new HAL that can detect AP61 to make OpenWrt? works on it. /Eric

11/16/06 16:12:03 changed by Eric L. Chen <lihong.chen@gmail.com>

To supplement: Since WiSoC supports up to 16MB flash rom, this patch is for less-eq 8MB flash. To make working with 1-16MB, Please chang 0xa87f0000 to 0xa8ff0000, and 0xa8800000 to 0xa9000000. But I didn't see any WiSoC board has more that 8MB flash.

02/01/07 14:04:11 changed by g_mutlu@hotmail.com

The AP61 board, I'm using, has "0x90" <devid> (according to according to the /ath/if_ath_ahb.c, init_ahb(), line 392) but this device id is not defined in the current /hal/ah_devid.h file. Instead, "0x91" is defined for AP61. Is there any update about this issue? Is there any workaround to use this device with current source code although device ids don't match?

(in reply to: ↑ 2 ) 06/15/07 17:54:24 changed by anonymous

Replying to Eric L. Chen <lihong.chen@gmail.com>:

Yes. Atheros made 0xbfc00000 alias to 0xa800000 in whole AR531X family. So, for all SoC boards with more than 4 MByte flash port, must use 0xa8000000 to access it.

I'm not 100% sure, but I remember seeing different flash memory addresses for ap43 and ap48 - probably 0x9fc00000 (and 0xbfc00000 aliasing to it). but I may be wrong.

06/16/07 00:35:53 changed by mentor

We should probably be doing better flash detection...

03/17/08 10:14:48 changed by mrenzmann

Someone attached a bunch of files to this ticket. If the purpose of these attachments was to submit changes/fixes, that person is kindly asked to resubmit them as patches (in unified diff format) instead. The procedure is explained here. If there are any questions about this procedure, please contact our support. Thanks.

06/27/08 15:51:28 changed by LLIyT

edited by mrenzmann

Hi Eric!

I porting linux and madwifi to custom board(like ap48) with 8mb flash! I added this patch but crashed... (continued in ticket #2018).